﻿using Syncfusion.SfSchedule.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection.Emit;
using System.Text;

using Xamarin.Forms;

namespace RecurrenceAppoointment_Sample
{
    public class ScheduleSamplePage : ContentPage
    {
        public ScheduleSamplePage()
        {
            SfSchedule sfschedule = new SfSchedule();
            CustomAppointment scheduleAppointment;
            DateTime currentDate = DateTime.Now;
            ScheduleAppointmentCollection appointmentCollection = new ScheduleAppointmentCollection();
            DateTime startTime = new DateTime(currentDate.Year, currentDate.Month, currentDate.Day, 10, 0, 0);
            DateTime endTime = new DateTime(currentDate.Year, currentDate.Month, currentDate.Day, 12, 0, 0);
            for (int i = 0; i < 3; i++)
            {//creating new instance for schedule
             
                sfschedule.ScheduleView = ScheduleView.MonthView;


                //Creating new events

                scheduleAppointment = new CustomAppointment();

                scheduleAppointment.StartTime = startTime.AddDays(i);
                scheduleAppointment.EndTime = startTime.AddHours(2);
                scheduleAppointment.Color = Color.Blue;
                scheduleAppointment.Subject = "Recurrence Appointment" + i.ToString();
                scheduleAppointment.IsRecursive = true;

                RecurrenceProperties recurrencePropertiesForAlternativeDay = new RecurrenceProperties();
                recurrencePropertiesForAlternativeDay.RecurrenceType = RecurrenceType.Daily;
                recurrencePropertiesForAlternativeDay.IsDailyEveryNDays = true;
                recurrencePropertiesForAlternativeDay.DailyNDays = 7;
                recurrencePropertiesForAlternativeDay.IsRangeRecurrenceCount = true;
                recurrencePropertiesForAlternativeDay.IsRangeNoEndDate = false;
                recurrencePropertiesForAlternativeDay.IsRangeEndDate = false;
                recurrencePropertiesForAlternativeDay.RangeRecurrenceCount = 5;
                recurrencePropertiesForAlternativeDay.RecurrenceRule = DependencyService.Get<IRecurrenceBuilder>().RRuleGenerator(recurrencePropertiesForAlternativeDay, scheduleAppointment.StartTime, scheduleAppointment.EndTime);

                scheduleAppointment.RecurrenceRule = recurrencePropertiesForAlternativeDay.RecurrenceRule;

                appointmentCollection.Add(scheduleAppointment);
            }
                
            sfschedule.DataSource = appointmentCollection;
            this.Content = sfschedule;
        }
    }
}
